import { defineConfig } from 'astro/config';
import node from "@astrojs/node";

import cloudflare from "@astrojs/cloudflare";

import react from "@astrojs/react";

// https://astro.build/config
export default defineConfig({
	output: "server",
	adapter: cloudflare(),
	integrations: [react()],
	vite: {
		server: {
			allowedHosts: ["nin0-pc.buri-roach.ts.net"]
		},
		resolve: {
			// Use react-dom/server.edge instead of react-dom/server.browser for React 19.
			// Without this, MessageChannel from node:worker_threads needs to be polyfilled.
			alias: import.meta.env.PROD && {
				"react-dom/server": "react-dom/server.edge"
			}
		}
	}
});